Attribute VB_Name = "Modul1"
Option Explicit
Const swDocDRAWING = 3
Const swBomTableColumnType_PartNumber = 202
Const swBomTableColumnType_Quantity = 203
Const swTableAnnotation_BillOfMaterials = 2
Const swTableAnnotation_WeldmentCutList = 4
Const swWeldTableColumnType_Quantity = 402
Const swWeldTableColumnType_ItemNumber = 401


Sub main()
    Dim swApp                   As Object
    Dim swModel                 As Object
    Dim swDraw                  As Object
    Dim swView                  As Object
    Dim swTable                 As Object
    Dim swFeat                  As Object
    Dim swBomFeat               As Object
    Dim bRet                    As Boolean
    Dim swAnn                   As Object
    Dim nNumCol                 As Long
    Dim nNumRow                 As Long
    Dim sRowStr                 As String
    Dim sTitStr                 As String
    Dim i                       As Long
    Dim j                       As Long
    Dim intOutHandle            As Integer
    Dim strOneLine              As String
    Dim SWXBom()                As String
    Dim sZelle                  As String
    Dim ArtikelSpalte           As Integer
    Dim Mass1Spalte             As Integer
    Dim PosSpalte               As Integer
    Dim MengenSpalte            As Integer
    Dim xlApp                   As Object
    Dim theTableAnnotation      As Object
    Dim RowType                 As Integer
    
    Set swApp = CreateObject("SldWorks.Application")
    Set swModel = swApp.ActiveDoc
    
    ' ist in SWX berhaupt etwas geffnet
    If swModel Is Nothing Then
        MsgBox "Keine Dokumentnte geffnet."
        End
    End If

    ' handelt es sich um eine Zeichnung
    If swModel.GetType <> swDocDRAWING Then
        MsgBox "Das Dokument ist keine Zeichnung."
        End
    End If
    
    Set swDraw = swModel
    Set swView = swDraw.GetFirstView
    Set swTable = swView.GetFirstTableAnnotation
          
    ' Gibt es eine Tabelle auf der Zeichnung
    If swTable Is Nothing Then
      MsgBox "Die Zeichnung enthlt keine Stckliste"
      End
    End If
    
    'Ist die Tabelle eine Stckliste oder Zuschnittsliste
    Do
      If (swTable.Type = swTableAnnotation_BillOfMaterials) Or (swTable.Type = swTableAnnotation_WeldmentCutList) Then
        Exit Do
      End If
      Set swTable = swTable.GetNext
      If swTable Is Nothing Then
         MsgBox "Die Zeichnung enthlt keine Stckliste"
         End
      End If
    Loop
    
    nNumCol = swTable.ColumnCount
    nNumRow = swTable.RowCount
    Mass1Spalte = 99 ' Falls keine Lnge mit drin ist, auf 99 setzen. 99 Spalten gibt es garantiert nicht
          
    ' Stli auslesen
    ' Zuerst die passenden Spalten suchen
    For j = 0 To nNumCol - 1
       sTitStr = Trim(swTable.GetColumnCustomProperty(j))
       Debug.Print sTitStr
       If sTitStr = "A-Nr." Then
          ArtikelSpalte = j
        ElseIf LCase(sTitStr) = "lnge" Or sTitStr = "swrohrlnge" Then
          Mass1Spalte = j
       End If
       RowType = swTable.GetColumnType(j)
       If (RowType = swBomTableColumnType_PartNumber) Or (RowType = swWeldTableColumnType_ItemNumber) Then
          PosSpalte = j
       ElseIf (RowType = swBomTableColumnType_Quantity) Or (RowType = swWeldTableColumnType_Quantity) Then
          MengenSpalte = j
       End If
     Next j
     ' Wir haben die Spalten gefunden, jetzt wird der Array gefllt
     ReDim SWXBom(nNumRow, 4)
     For i = 1 To nNumRow - 1
       SWXBom(i, 1) = swTable.Text(i, PosSpalte)
       SWXBom(i, 2) = swTable.Text(i, ArtikelSpalte)
       SWXBom(i, 3) = swTable.Text(i, MengenSpalte)
       If Mass1Spalte <> 99 Then ' Falls keine Lnge mit dabei ist
         If swTable.Text(i, Mass1Spalte) <> "" Then
           SWXBom(i, 4) = swTable.Text(i, Mass1Spalte)
           If Right(SWXBom(i, 4), 2) = "mm" Then SWXBom(i, 4) = Left(SWXBom(i, 4), Len(SWXBom(i, 4)) - 2)
         End If
       End If
     Next i
    Set swApp = Nothing
    Set swModel = Nothing
    Set swDraw = Nothing
    Set swView = Nothing
    Set swTable = Nothing
    
    ' Den Array nach Excel schreiben
    Set xlApp = CreateObject("Excel.Application")
    For i = 1 To nNumRow - 1
      For j = 1 To 4
        Cells(i, j).Value = SWXBom(i, j)
      Next j
    Next i
    Set xlApp = Nothing
End Sub

